﻿<?php
if (! defined ( 'BASEPATH' ))
	exit ( 'No direct script access allowed' );

/**
 * Home Class
 * @todo Control main actions 
 * @see index()
 * @see singin()
 * @see signout()
 *
 * @author dzungnv02
 *        
 */
class Home extends MX_Controller {
	const TOKENPW = 'violet';
	public function __construct() {
		parent::__construct ();
		$this->load->helper ( 'cookie' );
		$this->load->helper('language');
		$this->lang->load('messages', 'message');
	}
	
	/**
	 * function index
	 * @todo checked is sign-in then redirect to lecture page else redirect to sign-in page
	 */
	public function index() {
		$user_info = $this->session->userdata ( 'userInfo' );
		if ($user_info) {
			redirect ( '/frontend/lecture' );
		} else {
			$cookie_name = "siteCookie";
			if (isset ( $_COOKIE [$cookie_name] )) {
				$arr_user = parse_str ( $_COOKIE [$cookie_name] );
				$user_info = array (
						'username' => $arr_user ['username'],
						'user' => $arr_user ['user'],
						'us_id' => $arr_user ['us_id'],
                                                'is_viettel' => $arr_user ['is_viettel'],
						'logined_in' => TRUE 
				);
				$this->session->set_userdata ( 'userInfo', $user_info );
				redirect ( '/frontend/lecture' );
			} else {
				$this->load->view ( 'home' );
			}
		}
	}
	
	/**
	 * function signin
	 * @todo Execute sign-in action
	 */
	public function signin() {
		$username = $this->input->post ( 'username', TRUE );
		$password = $this->input->post ( 'password', TRUE );
		$autologin = ($this->input->post ( 'remember_me' ) == 'on') ? 1 : 0;
		$src = 'SBG';
		$token = md5 ( $username . self::TOKENPW );
		$this->load->model ( array (
				'user_model' 
		) );
		$result = $this->user_model->checkLogin ( $src, $token, $username, $password );
		if ($result['success'] == -1)
		{
			$this->session->set_flashdata ( 'login_api_error', TRUE );
			redirect ( '/frontend/home' );
			
		}else if ($result['success'] == 0)
		{
			$this->session->set_flashdata ( 'login_error', TRUE );
			redirect ( '/frontend/home' );
		}else{
			parse_str ( $result['data'] );
			$is_viettel = $this->is_viettel ( $phone );
			
			if ($autologin == 1) {
				$cookie_name = 'siteCookie';
				// $cookie_time = 7200;
				$cookie_time = 3600 * 24 * 30;
				setcookie ( $cookie_name, 'username=' . $username . '&user=' . $result['data'] . '&us_id=' . $id, time () + $cookie_time );
			}

			$userdata = array (
					'username' => $username,
					'user' => $result['data'],
					'us_id' => $id,
					'logined_in' => TRUE,
					'is_viettel' => $is_viettel 
			);
			$this->session->set_userdata ( 'userInfo', $userdata );
			redirect ( '/frontend/lecture' );
		}
	}
	
	/**
	 * funtion signout
	 * @todo Execute signout action
	 */
	public function signout() {
		//$this->session->sess_destroy ();
		// unset($this->session->userdata);
		$this->session->unset_userdata('userInfo');
		$cookie_name = "siteCookie";
		setcookie ( $cookie_name, 'username=' . "", time () - 3600 );
		redirect ( '/frontend/home' );
	}
	
	/**
	 * function is_viettel
	 * @param string $number
	 * @return 1:true;0:false
	 * @todo checked the phone number is viettel subscriber
	 */
	private function is_viettel($number) {
		$viettel = array (
				'096',
				'097',
				'098',
				'0163',
				'0164',
				'0165',
				'0166',
				'0167',
				'0168',
				'0169' 
		);
		foreach ( $viettel as $num ) {
			if (strpos ( $number, $num ) === 0) {
				return 1;
			}
		}
		return 0;
	}
	
	public function test(){
		$aryMatch = array();
		$phoneNumber = '987133325';
		$regex = '/^[1,9][0-9]{8,9}$/';
		if (preg_match('/^[1,9]([0-9]{8,9})$/', $phoneNumber, $aryMatch)){
			$phoneNumber = "0".$phoneNumber;
			echo $phoneNumber;
		}else{
			echo "Not match";
		}
	}
}

/* End of file home.php */
/* Location: ./application/modules/frontend/controllers/home.php */