<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/**
 * Class User
 * @todo Execute actions of user
 * 
 * @see function profile
 * @see function packageRegister
 * @see function finishRegisterPackage
 * @see function regpackage
 * @see function update_info
 * @see function update_user
 * @see function change_password
 * @see function trade_history
 * @see function getUserInfor 
 * @see function adminUpdateUser
 * @see function regis_history
 *  
 * @author dungnv02
 *
 */
class User extends MX_Controller {

    const TOKENPW = 'violet';

    public function __construct() {
        parent::__construct();
        $this->load->helper('cookie');
		$this->load->helper('language');
		$this->lang->load('messages', 'message');
    }

    public function profile() {
        $user_info = $this->session->userdata('userInfo');

        if ($user_info) {
            $this->load->model('User_model');
            $this->load->model('Servicepackage_model');
            $user = $user_info['user'];
            $us_id = $user_info['us_id'];
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $data = $this->get_data($src, $token, $us_id);
			$data['can_edit'] = 0;
            $u = $this->User_model->get_user_by_id($us_id);
			if ($u['p_id'] < 1) {
                $data['can_edit'] = 1;
            }
            if ($data['fullname']=="")
            {
                $data['can_edit'] = 1;
            }
            $data['current_tab'] = $this->uri->segment(4, 'edit-basic');
            $data['packages'] = $this->Servicepackage_model->getAllPackages();
            $data['is_viettel'] = isset($user_info['is_viettel']) ? $user_info['is_viettel']:FALSE;
            $data['provinces'] = lang('_PROVINCES_');
			
            $data = (is_array($u)) ? array_merge($data, $u) : $data;
            $data = (is_array($user_info)) ? array_merge($data, $user_info):$data;
			
            $this->load->view('frontend/user_profile', $data);
        } else {
            redirect('frontend/home');
        }
    }

    public function packageRegister() {
        $result = array();
        $input = $this->input->post();
        $this->load->model('user_model');
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            parse_str($user_info['user'], $info);
            $this->load->model('servicepackage_model');

            $package = $this->servicepackage_model->getPackage($input['p_id']);
            $user = $user_info['user'];
            $us_id = $user_info['us_id'];
            $user = $this->user_model->get_user_by_id($us_id);
			//$us = array();
			$user['district'] = $this->user_model->getDistrictByIdAndProvince($user['district'], $user['province']);
			
            $result['can_buy'] = 1;
            $result['can_edit'] = 0;
            
            if ($user['acc_balanced'] < $package['p_price']) {
                $result['can_buy'] = 0;
            }
            
			if(strtotime($user['expire_date'])<strtotime(date('Y-m-d'))){
				$result['can_edit'] = 1;
			}
            if ($user['p_id'] < 1) {
                $result['can_edit'] = 1;
            }
            if ($info['fullname']=="")
            {
                $result['can_edit'] = 1;
            }
            $result['info'] = $info;
            $result['user'] = $user;
            $result['package'] = $package;
            $result['modal'] = $this->load->view('frontend/package_register_modal', $result, true);
        } else {
            
        }
        echo json_encode($result);
    }

    public function finishRegisterPackage() {
        $result = array();
        $result['success'] = 0;
        $this->load->model('user_model');
        $input = $this->input->post();
		//print_r($input);
        $user_info = $this->session->userdata('userInfo');
        parse_str($user_info['user'], $info);
        if (isset($input['fullname'])) {
            if (strlen($input['fullname']) < 1) {
                $result['errors'][] = lang('_SBG_REGISTER_VIP_FULLNAME_REQUIRED_MSG');
            }
            if (strlen($input['school']) < 1) {
                $result['errors'][] = lang('_SBG_REGISTER_VIP_SCHOOL_REQUIRED_MSG');
            }
            if (!isset($result['errors'])) {
                $user_info = $this->session->userdata('userInfo');
                if ($user_info) {

                    $src = "SBG";
                    $us_id = $user_info['us_id'];
                    $input['password'] = '';
                    $input['oldpass'] = '';
                    $input['gender'] = '';
                    $input['email'] = '';
                    //$input['province'] = '';
                    $info['fullname'] = $input['fullname'];
                    $info['school'] = $input['school'];
                    $token = md5($us_id . self::TOKENPW);
                    $user = $this->get_data($src, $token, $us_id);
					//$input['district'] = '';
                    if ($input) {
                        $this->load->model('user_model');
                        $update = $this->user_model->update_user($src, $token, $input, $us_id);
                        $info = urldecode(http_build_query($info));
                        $userdata = array('username' => $user_info['username'], 'user' => $info, 'us_id' => $user_info['us_id'], 'logined_in' => TRUE, 'is_viettel' => $user_info['is_viettel']);
                        $this->session->set_userdata('userInfo', $userdata);
                    }
                }
            }
        }
        
        if (isset($result['errors'])) {
            echo json_encode($result);
            exit();
        }
        
        $this->load->model('servicepackage_model');
        $us_id = $user_info['us_id'];
        //$user = $this->user_model->get_user_by_id($us_id);
		$user = $this->user_model->getUserById($us_id);
		//$user['district'] = $this->user_model->getDistrictByIdAndProvince($user['district'], $user['province']);
        $package = $this->servicepackage_model->getPackage($input['p_id']);
        $user['acc_balanced'] = $user['acc_balanced'] - $package['p_price'];
        
        $today_dt = new DateTime(date('Y-m-d 00:00:00'));
        $expire_dt = new DateTime($user['expire_date']);
        
        $currentExpireDate = $user['expire_date'] == NULL || trim($user['expire_date']) == '' || $today_dt > $expire_dt  ? date('Y-m-d 00:00:00') : $user['expire_date'];
        $user['expire_date'] = date('Y-m-d', strtotime("+" . $package['p_period'] . " ".$package['p_unit'], strtotime($currentExpireDate))); 
        $user['p_id'] = $package['p_id'];
		$user['province'] = $input['province'];
		$user['district'] = $input['district'];
        $this->user_model->updateUser($us_id, $user);
        $user['expire_date'] = date("d-m-Y", (strtotime($user['expire_date'])));
        $result['expire_date'] = $user['expire_date'];
        $result['success'] = 1;
        $message = str_replace(':period:', date("d/m/Y", (strtotime($user['expire_date']))), lang('_SBG_REGISTER_VIP_SUCCESS_MSG'));
        $result['message'] = $message;

		$toDate = date("Y-m-d", (strtotime($result['expire_date'])));
		$this->user_model->insertRegisterVipLog($user['cellphone'],$package['p_code'], false);
        echo json_encode($result);
    }

    public function regpackage() {
        $user_info = $this->session->userdata('userInfo');
        parse_str($user_info['user'], $info);
        $p_id = $this->input->post('p_id', TRUE);

        $us_id = (int) $info['id'];
        $this->load->model('servicepackage_model');
        $this->load->model('user_model');

        $user = $this->user_model->get_user_by_id($us_id);
		$user['district'] = $this->user_model->getDistrictByIdAndProvince($user['district'], $user['province']);
        $package = $this->servicepackage_model->getPackage($p_id);

        if ($user['acc_balanced'] < $package['p_price']) {
			$aryPatterns = array('/:acc_balanced:/');
			$message = preg_replace($aryPatterns, array(number_format($user['acc_balanced'], 0)), lang('_SBG_ACC_BALANCE_LESS_PACKAGE_PRICE_MSG'));
        } else {
            $user['acc_balanced'] = $user['acc_balanced'] - $package['p_price'];
            
            $today_dt = new DateTime(date('Y-m-d 00:00:00'));
            $expire_dt = new DateTime($user['expire_date']);
            
            $currentExpireDate = $user['expire_date'] == NULL || trim($user['expire_date']) == ''  || $today_dt > $expire_dt ? date('Y-m-d 00:00:00') : $user['expire_date'];

            $user['expire_date'] = date('Y-m-d', strtotime("+" . $package['p_period'] . " " . $package['p_unit'], strtotime($currentExpireDate)));
            //$user['expire_date'] = date("Y-m-d", (strtotime($user['expire_date']) - 1));

            $user['p_id'] = $package['p_id'];

            $this->user_model->updateUser($us_id, $user);
			$aryPatterns = array('/:period:/');
			$message = preg_replace($aryPatterns, array(date('d-m-Y', strtotime($user['expire_date']))), lang('_SBG_REGISTER_VIP_SUCCESS_MS')); 
			$this->user_model->insertRegisterVipLog($user['cellphone'], $package['p_code'], false);
        }

        $this->session->set_flashdata('message', $message);
        redirect('frontend/user/profile#services-register');
    }

    private function get_data($src, $token, $us_id) {
        $this->load->model('user_model');
        $user = $this->user_model->get_user_info($src, $token, $us_id);

        if (strpos($user, '&')) {
            parse_str($user);
            $us = $this->user_model->get_user_by_id($us_id);
			$us['district'] = $this->user_model->getDistrictByIdAndProvince($us['district'], $province);
            $data = array('us_id' => $us_id, 'username' => $username, 'fullname' => $fullname,
                'gender' => $gender, 'email' => $email, 'phone' => $phone, 'school' => $school, 'province' => $province, 'district' => $us['district'],
                'acc_balanced' => $us['acc_balanced'], 'expire_date' => $us['expire_date'], 'date_diff' => $this->dateDiff($us['expire_date'])
            );
            return $data;
        } else {
            return "";
        }
    }

    private function dateDiff($expire_date) {
        $date1 = date("Y-m-d");
        if ((strtotime($expire_date) - strtotime($date1)) < 0)
            return "0 ngày còn lại";
        $diff = strtotime($expire_date) - strtotime($date1);
        $years = floor($diff / (365 * 60 * 60 * 24));
        $months = floor(($diff - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
        $days = floor(($diff - $years * 365 * 60 * 60 * 24 - $months * 30 * 60 * 60 * 24) / (60 * 60 * 24));
        if ($years > 0) {
            return $years . " năm, " . $months . " tháng, " . $days . " ngày còn lại";
        } else {
            if ($months > 0) {
                return $months . " tháng, " . $days . " ngày còn lại";
            } else {
                return $days . " ngày còn lại";
            }
        }
    }
    
	public function update_info() {
        $result['success'] = 0;
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $us_id = $user_info['us_id'];
            $result = array();
            $result['success'] = 0;
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $user = $this->get_data($src, $token, $us_id);
            $input = $this->input->post();
            parse_str($user_info['user'], $info);
            if ($input) {
				if (array_key_exists('fullname', $input)) {
					if (strlen($input['fullname']) == 0) {
						$result['errors'][] = array("content"=>lang('_SBG_FULLNAME_REQUIRED_MSG'),"field"=>"fullname");
					}
				}else{
					$input['fullname'] = $user['fullname'];
				}
                if (strlen($input['school']) == 0) {
                    $result['errors'][] = array("content"=>lang('_SBG_REGISTER_VIP_SCHOOL_REQUIRED_MSG'),"field"=>"school");
                }
				if (strlen($input['province']) == 0) {
                    $result['errors'][] = array("content"=>lang('_SBG_PROVINCE_REQUIRED_MSG'),"field"=>"province");
                }
                $input['password'] = '';
                $input['oldpass'] = '';
                $this->load->model('user_model');
                if (!isset($result['errors'])) {
                    $result['data'] = $this->user_model->update_user($src, $token, $input, $us_id);
                    $result['success'] = 1;
                    $info['fullname'] = $input['fullname'];
                    $info['school'] = $input['school'];
                    $info = urldecode(http_build_query($info));
                    $userdata = array('username' => $user_info['username'], 'user' => $info, 'us_id' => $user_info['us_id'], 'logined_in' => TRUE, 'is_viettel' => $user_info['is_viettel']);
                    $this->session->set_userdata('userInfo', $userdata);
                }
                echo json_encode($result);
            }
        } else {
            redirect('frontend/home');
        }
    }
    
    public function update_user() {
        $us_id = $this->uri->segment(4);
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $result = array();
            $result['success'] = 0;
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $user = $this->get_data($src, $token, $us_id);
            $input = $this->input->post();
            if ($input) {
                $input['username'] = $user['username'];
                if (array_key_exists('fullname', $input)) {
                    if (strlen($input['fullname']) == 0) {
                        $result['errors']['fullname_err'] = lang('_SBG_FULLNAME_REQUIRED_MSG');
                    }
                } else {
                    $input['fullname'] = $user['fullname'];
                }

                $input['password'] = '';
                $input['oldpass'] = '';
                $this->load->model('user_model');
                if (!isset($result['errors'])) {
                    $result['data'] = $this->user_model->update_user($src, $token, $input, $us_id);
                    $result['success'] = 1;
                }
                echo json_encode($result);
            }
        } else {
            redirect('frontend/home');
        }
    }

    public function change_password() {
        $us_id = $this->uri->segment(4);
        $user_info = $this->session->userdata('userInfo');
        if ($user_info) {
            $this->load->model('user_model');
            $us_id = $user_info['us_id'];
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $input = $this->input->post();

            if (strlen($input['passwd']) == 0) {
                $result['errors']['passwd_old_err'] = lang('_SBG_PASSWORD_REQUIRED_MSG');
            }
			
            if (strlen($input['passwd_new']) == 0) {
                $result['errors']['passwd_new_err'] = lang('_SBG_PASSWORD_REQUIRED_MSG');
            } else if (strcmp($input['passwd'], $input['passwd_new']) == 0) {
                $result['errors']['passwd_new_err'] = lang('_SBG_PASSWORD_DUPLICATE_MSG');
            }else
			{
				if (!preg_match('/^([0-9a-zA-Z]{6,65})*$/', $input['passwd_new']))
				{
					$result['errors']['passwd_new_err'] = lang('_SBG_USER_PASSWORD_CHANGE_REQUIRED_MSG');
				}
			}
			
            if ($input['passwd_new'] != $input['confirm_passwd_new']) {
                $result['errors']['confirm_passwd_new_err'] = lang('_SBG_PASSWORD_CONFIRM_MSG');
            }

            if (!isset($result['errors'])) {
                $user = array('username' => $user_info['username'], 'fullname' => null, 'gender' => null, 'email' => null, 'school' => null, 'province' => null, 'password' => $input['passwd_new'], 'oldpass' => $input['passwd']);
                $data = $this->user_model->update_user($src, $token, $user, $us_id);
                parse_str($data);
				error_log('API return ---- Data: '. var_export($data, TRUE). "\n", 3, '/srv/www/sbg/log/changepass.log');
                switch ((int)$status) {
                    case 0:
                        $result['success'] = 1;
                        break;
                    case 6:
                        $result['errors']['passwd_old_err'] = lang('_SBG_OLD_PASSWORD_FAIL_MSG');
                        break;
                    default:
                        break;
                }
            }

            echo json_encode($result);
        } else {
            redirect('frontend/home');
        }
    }
	
	public function trade_history()
	{
		$this->load->helper('pagging');
		$us_id = $this->uri->segment(4);

        $user_info = $this->session->userdata('userInfo');
		$admin_info = $this->session->userdata('adminInfo');

        if ($user_info || $admin_info) 
		{
			$data['us_id'] = $us_id;
			$data['perpage'] = 10;
			$data['current_page'] = $this->uri->segment(6, 1);
			$data['start'] = ($data['current_page'] - 1) * $data['perpage'];
			$this->load->model('user_model');
			$result = $this->user_model->getPaidlog($data);
			$data['total'] = $this->user_model->countPaiglogs($us_id);
			$data['num_links'] = 2;
			$data['paging_url'] = base_url() . "frontend/user/trade_history/".$us_id."/page/";
			$data['paging'] = pagging($data);
			$paidlogs = array();
			foreach ($result as $paidlog):
				$paidlog['amount'] = number_format($paidlog['amount'], 0);
				$paidlog['paid_time'] = date('d/m/Y H:i:s', strtotime($paidlog['paid_time']));
				array_push($paidlogs, $paidlog);
			endforeach;
			$data['paidlogs'] = $paidlogs;
			echo json_encode($data);
		}else {
            redirect('frontend/home');
        }
	}
	public function getUserInfor() 
        {
            $this->load->model('User_model');
            $data=array();
            $us_id = $this->uri->segment(4);
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $user = $this->User_model->get_user_info($src, $token, $us_id);
            parse_str($user,$user);
            $local=$this->User_model->get_user_by_id($us_id);
            $data['user']=  array_merge($user,$local);        
            $this->lang->load('messages', 'message');
            $admin=$this->session->userdata('adminInfo');
            $roles=array();
            foreach ($admin['roles'] as $role)
            {
                $roles[]=$role['role_name'];
            }
            $data['roles']=$roles;
            $data['provinces'] = lang('_PROVINCES_');
            $result['modal']=$this->load->view('frontend/user_infor', $data, TRUE);               
            echo json_encode($result);
                    
        }
        public function adminUpdateUser()
        {
            $this->load->model('User_model');
            $input=$input = $this->input->post();
            $us_id=$input["us_id"];
            $src = "SBG";
            $token = md5($us_id . self::TOKENPW);
            $api['fullname']=$input['fullname'];
            $api['school']=$input['school'];
            $local['district']=$input['district'];
            $local['province']=$input['province'];
            $update = $this->User_model->update_user($src, $token, $api, $us_id);
            $this->User_model->update_local_user($local,$us_id);
            $result['success']=1;
            echo json_encode($result);
        }
	public function regis_history()
	{
		$this->load->model('servicepackage_model');
		$this->load->helper('pagging');
		$us_id = $this->uri->segment(4);
		$this->load->model('user_model');
		$user = $this->user_model->get_user_by_id($us_id);
		$username = $user['cellphone'];
		$user_info = $this->session->userdata('userInfo');
		$admin_info = $this->session->userdata('adminInfo');
		if ($user_info || $admin_info) 
		{
			$data['us_id'] = $us_id;
			$data['username'] = $username;
			$data['acc_balanced'] = number_format($user['acc_balanced']);
			$data['perpage'] = 10;
			$data['current_page'] = $this->uri->segment(6, 1);
			$data['start'] = ($data['current_page'] - 1) * $data['perpage'];
			$this->load->model('user_model');
			$result = $this->user_model->getPackagelog($data);
			$results = array();
			foreach($result as $re){
				if ($re['p_code']>0){
					$p_price =  $this->servicepackage_model->getPackagePriceByCode($re['p_code']);
					$re['amount'] = -$p_price;
				}
				array_push($results, $re);
			}
			$data['total'] = $this->user_model->countPackagelogs($username, $us_id);
			$data['num_links'] = 2;
			$data['paging_url'] = base_url() . "frontend/user/regis_history/".$us_id."/page/";
			$data['paging'] = pagging($data);
			$packagelogs = array();
			foreach ($results as $packagelog):
				$packagelog['created_time'] = date('d/m/Y H:i:s', strtotime($packagelog['created_time']));
				array_push($packagelogs, $packagelog);
			endforeach;
			$data['packagelogs'] = $packagelogs;
			echo json_encode($data);
		}else
		{
			 redirect('frontend/home');
		}
		
	}
	
	function getDistrict(){
		
		$user_info = $this->session->userdata('userInfo');
		$admin_info = $this->session->userdata('adminInfo');
		if ($user_info || $admin_info) {
			$result = array();
			$provinceId = $this->uri->segment(4);
			$this->load->model ( 'user_model' );
			if ($provinceId){
				$results = $this->user_model->getDistrictByProvince($provinceId);
			}
			echo json_encode($results);
		}else{
			show_404();
		}
		
	}

}
